<?php
/**
 * @package JFBConnect - K2 Profile Integration
 * @copyright (C) 2010-2013 by SourceCoast - All rights reserved
 * @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 */
defined('_JEXEC') or die('Restricted access');

jimport('sourcecoast.plugins.socialprofile');

class plgSocialProfilesAgoraPro extends SocialProfilePlugin
{
    var $_userTableRow;

    function __construct(&$subject, $params)
    {
        $this->_componentFolder = JPATH_SITE . '/components/com_agorapro';
        $this->_componentFile = '';
        parent::__construct($subject, $params);

        $this->defaultSettings->set('import_avatar', '1');
        $this->defaultSettings->set('import_always', '0');
        $this->defaultSettings->set('registration_show_fields', '0'); //0=None, 1=Required, 2=All
        $this->defaultSettings->set('imported_show_fields', '0'); //0=No, 1=Yes
    }

    protected function createUser()
    {
        $this->importSocialProfile();
        return true;
    }

    /*     * * End Trigger Overrides ** */
    protected function saveProfileField($fieldId, $value)
    {
        if ($fieldId == 'birthday')
            $value = strtotime($value);
        else if ($fieldId == "gender")
        {
            switch ($value)
            {
                case 'male':
                    $value = 1;
                    break;
                case 'female':
                    $value = 2;
                    break;
                default:
                    $value = 0;
                    break;
            }
        }
        $dbo = JFactory::getDBO();
        $query = 'UPDATE #__agorapro_users ' .
                ' SET `' . $fieldId . '`  = ' . $dbo->Quote($value) .
                '  WHERE `id` = ' . $this->joomlaId;
        $dbo->setQuery($query);
        $dbo->query();
    }

    protected function setAvatar($socialAvatar)
    {
        require_once(JPATH_ADMINISTRATOR . '/components/com_agorapro/helpers/initiate.php');

        $params = agoraFactory::getAddonParams('avatar');
        $params_upload_dir_sys = JPATH_ROOT . '/' . $params->upload_dir;

        $dest = $params_upload_dir_sys . '/avatar_' . $this->joomlaId . '.' . JFile::getExt($socialAvatar);
        // delete any previous avatars for the user
        $old_avatars = JFolder::files($params_upload_dir_sys, 'avatar_' . $this->joomlaId . '\.', false, true, array('index.html'));
        if ($old_avatars && is_array($old_avatars) && count($old_avatars))
            JFile::delete($old_avatars);

        $socialAvatarFile = $this->getAvatarPath() . DS . $socialAvatar;
        if (JFile::copy($socialAvatarFile, $dest))
        {
            $image = agoraFactory::getImage();
            $image->resize($dest, $dest, (int)$params->width, (int)$params->width);
            return true;
        } else
            return false;

    }

    protected function setDefaultAvatar()
    {
        return true;
    }

    protected function getProfileFields()
    {
        $agoraFields = array();
        $agoraFields[] = (object)array('id' => "title", "name" => "Title");
        $agoraFields[] = (object)array('id' => "gender", "name" => "Gender");
        $agoraFields[] = (object)array('id' => "location", "name" => "Location");
        $agoraFields[] = (object)array('id' => "url", "name" => "Website");
        $agoraFields[] = (object)array('id' => "birthday", "name" => "Birthdate");
        $agoraFields[] = (object)array('id' => "signature", "name" => "Signature");
        $agoraFields[] = (object)array('id' => "aboutme", "name" => "About Me");
        $agoraFields[] = (object)array('id' => "interests", "name" => "Interests");

        return $agoraFields;
    }

}