<?php
/**
 * @package        JFBConnect
 * @copyright (C) 2009-2013 by Source Coast - All rights reserved
 * @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 */
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.controller');

class JFBConnectControllerAjax extends JControllerLegacy
{
    function display()
    {
        // Not to be called directly
        JFactory::getApplication()->exit(0);
    }

    function friends()
    {
        $friends = JFBCFactory::provider('facebook')->api('/me/friends?fields=id,name,link,picture');

        if (empty($friends) || !isset($friends['data']) || empty($friends['data']))
        {
            JFactory::getApplication()->close(0);
        }

        $search = strtolower(JRequest::getString('q', 'GET'));
        $friends = $friends['data'];
        $matchedFriends = array();
        foreach ($friends as $friend)
        {
            if (!(isset($friend['id']) && isset($friend['name'])))
                continue;

            if (strpos(strtolower($friend['name']), $search) !== false)
            {
                $matchedFriend = array('label' => $friend['name'], 'value' => $friend['id']);
                if (isset($friend['picture']['data']['url']))
                    $matchedFriend['picture'] = $friend['picture']['data']['url'];
                if (isset($friend['link']))
                    $matchedFriend['link'] = $friend['link'];
                $matchedFriends[] = $matchedFriend;
                unset($matchedFriend);
            }
        }
        if (!empty($matchedFriends))
        {
            echo json_encode($matchedFriends);
        }
        JFactory::getApplication()->close(0);
    }

    function places()
    {
        $search = JRequest::getString('q', '');
        $params = array(
            'type' => 'place',
            'distance' => 1000,
            'fields' => 'id,name,location,picture,were_here_count,is_published,link',
            'center' => '37.787943,-122.407548', // Union Square San Francisco
            'q' => trim($search),
            'limit' => 5
        );

        $center = JRequest::getVar('center');
        if ($center)
            $params['center'] = trim($center);

        $results = JFBCFactory::provider('facebook')->api('search', $params, true, 'GET');

        $results = $results['data'];
        $clean_results = array();
        foreach ($results as $result)
        {
            if (!(isset($result['is_published']) && $result['is_published'] && isset($result['id']) && $result['id'] && isset($result['name']) && $result['name']))
                continue;
            $clean_result = array('label' => trim($result['name']), 'value' => $result['id'], 'link' => $result['link']);

            // build location components for use in place summary
            if (isset($result['location']))
            {
                $location = array();

                if (isset($result['location']['street']) && $result['location']['street'])
                    $location['street'] = trim($result['location']['street']);
                if (isset($result['location']['city']) && $result['location']['city'] && isset($result['location']['state']) && $result['location']['state'])
                    $location['area'] = trim($result['location']['city'] . ', ' . $result['location']['state']);
                else if (isset($result['location']['state']) && $result['location']['state'] && isset($result['location']['country']) && $result['location']['country'])
                    $location['area'] = trim($result['location']['state'] . ', ' . $result['location']['country']);
                else if (isset($result['location']['country']) && $result['location']['country'])
                    $location['area'] = trim($result['location']['country']);

                if (!empty($location))
                    $clean_result['location'] = $location;
                unset($location);
            }

            if (isset($result['were_here_count']) && $result['were_here_count'])
                $clean_result['were_here_count'] = (int)$result['were_here_count'];

            if (isset($result['picture']['data']['url']) && $result['picture']['data']['url'])
                $clean_result['picture'] = $result['picture']['data']['url'];

            $clean_results[] = $clean_result;
            unset($clean_result);
        }
        echo json_encode($clean_results);
        JFactory::getApplication()->close(0);
    }


}
