<?php
/**
 * @package        JFBConnect
 * @copyright (C) 2009-2013 by Source Coast - All rights reserved
 * @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 */


    JLoader::register('JOauth2Client', JPATH_SITE . '/components/com_jfbconnect/libraries/joomla/oauth2/client.php');


JLoader::register('JFBConnectProvider', JPATH_SITE . '/components/com_jfbconnect/libraries/provider.php');
JLoader::register('JFBConnectProfile', JPATH_SITE . '/components/com_jfbconnect/libraries/profile.php');
JLoader::discover('JFBConnectProvider', JPATH_SITE . '/components/com_jfbconnect/libraries/provider/');
JLoader::discover('JFBConnectProfile', JPATH_SITE . '/components/com_jfbconnect/libraries/profile/');

jimport('joomla.filesystem.folder');

class JFBCFactory
{
    public static function provider($name)
    {
        static $providers = array();
        if (!isset($providers[$name]))
        {
            $className = 'JFBConnectProvider' . $name;
            $providers[$name] = new $className();
        }
        return $providers[$name];
    }


    public static function getAllProviders()
    {
        static $allProviders;
        if (!isset($allProviders))
        {
            $allProviders = array();
            $files = JFolder::files(JPATH_SITE . '/components/com_jfbconnect/libraries/provider/');
            foreach ($files as $file)
            {
                $allProviders[] = self::provider(str_replace(".php", "", $file));
            }
        }
        return $allProviders;
    }

    public static function config()
    {
        static $configModel = null;
        if (!isset($configModel))
        {
            require_once(JPATH_ADMINISTRATOR . '/components/com_jfbconnect/models/config.php');
            $configModel = new JFBConnectModelConfig();
        }
        return $configModel;
    }

    // Return an instance of the usermap model, always creating it
    public static function usermap()
    {
        $userMapModel = new JFBConnectModelUserMap();
        return $userMapModel;
    }
}