<?php
/**
 * @package        JFBConnect
 * @copyright (C) 2009-2013 by Source Coast - All rights reserved
 * @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 */
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die('Restricted access');

jimport('sourcecoast.utilities');

include_once(JPATH_ADMINISTRATOR . '/components/com_jfbconnect/models/usermap.php');
include_once(JPATH_SITE . '/components/com_jfbconnect/libraries/profile.php');

class JFBConnectProvider extends JObject
{
    var $name;
    var $appId;
    var $secretKey;

    var $auth;
    var $profile;
    var $client;

    protected $providerUserId;
    private static $libraryInstance;

    public static function getInstance()
    {
        if (!isset(self::$libraryInstance))
        {
            self::$libraryInstance = new JFBConnectProviderFacebook();
            // After the instance is grabbed, get the Javascript code to insert
            // Don't do this in the constructor as initiating the Javascript calls functions which need
            //   this very instance
            $app = JFactory::getApplication();
            if (!$app->isAdmin())
            {
                // Set whether, on this page load, the user should be checked for a new mapping (i.e. they were just on the login/register page)
                $session = JFactory::getSession();
                $checkNewMapping = $session->get('jfbcCheckNewMapping', false);
                self::$libraryInstance->checkNewMapping = $checkNewMapping;
            }
        }

        return self::$libraryInstance;
    }

    function __construct()
    {
        $this->configModel = JFBCFactory::config();
        $this->appId = $this->configModel->getSetting($this->name . '_app_id');
        $this->secretKey = $this->configModel->getSetting($this->name . '_secret_key');

        $profileClass = 'JFBConnectProfile' . $this->name;
        $this->profile = new $profileClass($this);
    }

    var $initialRegistration = false;

    function setInitialRegistration()
    {
        $this->initialRegistration = true;
    }

    public function setSessionToken()
    {
        $token = $this->getToken();
        JFactory::getApplication()->setUserState('com_jfbconnect.' . $this->name . '.token', json_encode($token));
    }

    function getToken()
    {
    }

    public function onAfterInitialise()
    {

    }

    public function onAfterDispatch()
    {

    }

    public function onAfterRender()
    {

    }

    function loginButton($params = null)
    {
        return "";
    }

    function connectButton($params)
    {
        return "";
    }

    function logoutButton($params)
    {
        return "";
    }

    function avatar($params)
    {

    }

    /* getProviderUserId
    * The new way to get the userId from Facebook as of v5.1
    */
    function getProviderUserId()
    {
    }

    /* getMappedUserId
     * Return the mapped userId from Joomla
     */
    function getMappedUserId()
    {

    }

    /* onAfterLogin
    * Any functional calls that the provider needs to make directly before the user is logged in (or automatically registered)
    */
    public function onBeforeLogin()
    {
    }

    public function checkNewMapping()
    {
        $newMappingEnabled = JFactory::getApplication()->getUserState('com_jfbconnect.' . $this->name . '.checkForNewMapping', false);
        if ($newMappingEnabled)
        {
            $providerId = $this->getProviderUserId();
            if ($providerId != null)
            {
                JFBCFactory::usermap()->map(JFactory::getUser()->get('id'), $providerId, $this->name);
            }
        }

        JFactory::getApplication()->setUserState('com_jfbconnect.' . $this->name . '.checkForNewMapping', null);
    }

}