<?php
/**
 * @package        JFBConnect
 * @copyright (C) 2009-2013 by Source Coast - All rights reserved
 * @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 */
// No direct access
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.view');
jimport('sourcecoast.utilities');

class JFBConnectViewLoginregister extends JViewLegacy
{
    var $_loginRegisterModel;

    function display($tpl = null)
    {
        $app = JFactory::getApplication();
        $input = JFactory::getApplication()->input;
        $provider = $input->getCmd('provider', null);
        if (!$provider)
            $app->redirect('index.php');

        $provider = JFBCFactory::provider($provider);
        $providerUserId = $provider->getProviderUserId();
        $profile = $provider->profile->fetchProfile($providerUserId, array('first_name', 'last_name', 'email', 'full_name'));
        $this->_loginRegisterModel = $this->getModel('loginregister');

        if ($providerUserId == null)
            $app->redirect('index.php');

        $args = array($provider->name);
        $profileFields = $app->triggerEvent('socialProfilesOnShowRegisterForm', $args);

        // Get previously filled in values
        $postData = $app->getUserState('com_jfbconnect.registration.data', array());

        $email1 = '';
        $email2 = '';

        SCUserUtilities::getDisplayEmail($postData, $profile->get('email'), $email1, $email2);
        $configModel = JFBCFactory::config();
        $providerUsername = SCUserUtilities::getDisplayUsername($postData, $profile->get('first_name'), $profile->get('last_name'), $email1, $providerUserId, $configModel, $this->_loginRegisterModel);
        $providerPassword = SCUserUtilities::getDisplayPassword($configModel, $this->_loginRegisterModel);
        $providerMemberName = SCUserUtilities::getDisplayNameByFullName($postData, $profile->get('full_name'));

        $language = JFactory::getLanguage();
        $language->load('com_users');
        JModelLegacy::addIncludePath(JPATH_SITE . '/components/com_users/models');
        $userModel = JModelLegacy::getInstance('Registration', 'UsersModel');
        $this->data = $userModel->getData();
        JForm::addFormPath(JPATH_SITE . '/components/com_users/models/forms');
        JForm::addFieldPath(JPATH_SITE . '/components/com_users/models/fields');
        $this->form = $userModel->getForm();

        // Setup the fields we can pre-populate
        // To do: Give option to show/hide the name on the form
        $this->form->setValue('name', null, $providerMemberName);

        $this->form->setValue('username', null, $providerUsername);
        if (!$configModel->getSetting('registration_show_username') && $providerUsername != '')
        {
            $this->form->setFieldAttribute('username', 'type', 'hidden');
        }

        $this->form->setValue('email1', null, $email1);
        $this->form->setValue('email2', null, $email2);
        if (!$configModel->getSetting('registration_show_email') && $email1 != '' && $email2 != '')
        {
            $this->form->setFieldAttribute('email1', 'type', 'hidden');
            $this->form->setFieldAttribute('email2', 'type', 'hidden');
        }

        if (!$configModel->getSetting('registration_show_password') && $providerPassword != '')
        {
            $this->form->setValue('password1', null, $providerPassword);
            $this->form->setValue('password2', null, $providerPassword);
            $this->form->setFieldAttribute('password1', 'type', 'hidden');
            $this->form->setFieldAttribute('password2', 'type', 'hidden');
        }

        // Set an inputbox style on all the input elements so that inherited template styles look better
        $this->form->setFieldAttribute('name', 'class', 'inputbox');
        $this->form->setFieldAttribute('username', 'class', 'validate-username inputbox');
        $this->form->setFieldAttribute('email1', 'class', 'inputbox');
        $this->form->setFieldAttribute('email2', 'class', 'inputbox');
        $this->form->setFieldAttribute('password1', 'class', 'validate-password inputbox');
        $this->form->setFieldAttribute('password2', 'class', 'validate-password inputbox');

        //Check for form validation from each of the plugins
        $areProfilesValidating = $app->triggerEvent('socialProfilesAddFormValidation');
        $defaultValidationNeeded = true;
        foreach ($areProfilesValidating as $hasDoneValidation)
        {
            if ($hasDoneValidation == true)
            {
                $defaultValidationNeeded = false;
                break;
            }
        }

        //Check to see if JLinked is installed
        $jLinkedLoginButton = "";
        if (SCSocialUtilities::isJLinkedInstalled())
        {
            require_once(JPATH_ROOT . '/components/com_jlinked/libraries/linkedin.php');
            $jLinkedLibrary = JLinkedApiLibrary::getInstance();

            SCStringUtilities::loadLanguage('com_jlinked');
            $loginText = JText::_('COM_JLINKED_LOGIN_USING_LINKEDIN');

            $jLinkedLoginButton = '<link rel="stylesheet" href="components/com_jlinked/assets/jlinked.css" type="text/css" />';
            $jLinkedLoginButton .= '<div class="jLinkedLogin"><a href="' . $jLinkedLibrary->getLoginURL() . '"><span class="jlinkedButton"></span><span class="jlinkedLoginButton">' . $loginText . '</span></a></div>';
        }

        // Setup the view appearance
        // TODO: Make the addStyleSheet into a Utilities function to be used elsewhere.
        $displayType = $configModel->getSetting('registration_display_mode');;
        $css = JPath::find($this->_path['template'], 'loginregister.css');
        $css = str_replace(JPATH_ROOT . '/', JURI::base(), $css);
        $doc = JFactory::getDocument();
        $doc->addStyleSheet($css);

        // get the other providers, for showing their login buttons
        $allProviders = JFBCFactory::getAllProviders();
        $altProviders = array();
        foreach ($allProviders as $p)
        {
            if ($p->name != $provider->name)
                $altProviders[] = $p;
        }
        // Set the session bit to check for a new login on next page load
        SCSocialUtilities::setJFBCNewMappingEnabled();

        $this->assignRef('providerUserId', $providerUserId);
        $this->assignRef('profile', $profile);
        $this->assignRef('configModel', $configModel);
        $this->assignRef('profileFields', $profileFields);
        $this->assignRef('jLinkedLoginButton', $jLinkedLoginButton);
        $this->assignRef('defaultValidationNeeded', $defaultValidationNeeded);
        $this->assignRef('displayType', $displayType);
        $this->assignRef('providerName', $provider->name);
        $this->assignRef('altProviders', $altProviders);

        parent::display($tpl);
    }

}
