<?php
/**
 * @package        JFBConnect
 * @copyright (C) 2009-2013 by Source Coast - All rights reserved
 * @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 */
// no direct access
defined('_JEXEC') or die('Restricted access');

jimport('joomla.filesystem.folder');

class com_JFBConnectInstallerScript
{
    var $jfbcVersion = "5.1.2"; // Same as the XML version
    var $finalDBVersion = "5.1.0"; // If database updates occur, increment this number
    var $libraryVersion = "2.2.2";
    var $packages = array();

    var $systemPluginEnabled = '0';
    var $authPluginEnabled = '0';
    var $userPluginEnabled = '0';
    var $contentPluginEnabled = '0';

    var $installedRow = '0';

    private $betaFixRequired = false; // Remove in v5.1

    public function __construct()
    {
        
        $jVersion = "j2.5";
         //SC16
         //SC30

        $this->packages[] = array('name' => 'JFBConnect Authentication Plugin', 'file' => 'plg_authentication_jfbconnectauth_' . $jVersion . '_v5.1.0.zip', 'install' => true);
        $this->packages[] = array('name' => 'JFBConnect User Plugin', 'file' => 'plg_user_jfbconnectuser_' . $jVersion . '_v5.1.2.zip', 'install' => true);
        $this->packages[] = array('name' => 'JFBConnect System Plugin', 'file' => 'plg_system_jfbcsystem_' . $jVersion . '_v5.1.2.zip', 'install' => true);
        $this->packages[] = array('name' => 'JFBConnect Content Plugin', 'file' => 'plg_content_jfbccontent_' . $jVersion . '_v5.1.0.zip', 'install' => true);
        $this->packages[] = array('name' => 'SCLogin', 'file' => 'modules/mod_sclogin_' . $jVersion . '_v3.1.2.zip', 'install' => true);
        $this->packages[] = array('name' => 'SourceCoast Social Library', 'file' => 'lib_sourcecoast_' . $jVersion . '_v2.2.2.zip', 'install' => true);
        //Social Modules
        $this->modules[] = array('name' => 'JFBCComments', 'file' => 'modules/mod_jfbccomments_' . $jVersion . '_v5.1.0.zip', 'install' => true);
        $this->modules[] = array('name' => 'JFBCFan', 'file' => 'modules/mod_jfbcfan_' . $jVersion . '_v5.1.0.zip', 'install' => true);
        $this->modules[] = array('name' => 'JFBCFeed', 'file' => 'modules/mod_jfbcfeed_' . $jVersion . '_v5.1.0.zip', 'install' => true);
        $this->modules[] = array('name' => 'JFBCFollow', 'file' => 'modules/mod_jfbcfollow_' . $jVersion . '_v5.1.0.zip', 'install' => true);
        $this->modules[] = array('name' => 'JFBCFriends', 'file' => 'modules/mod_jfbcfriends_' . $jVersion . '_v5.1.0.zip', 'install' => true);
        $this->modules[] = array('name' => 'JFBCLike', 'file' => 'modules/mod_jfbclike_' . $jVersion . '_v5.1.0.zip', 'install' => true);
        $this->modules[] = array('name' => 'JFBCRecommendations', 'file' => 'modules/mod_jfbcrecommendations_' . $jVersion . '_v5.1.0.zip', 'install' => true);
        $this->modules[] = array('name' => 'JFBCRecommendationsBar', 'file' => 'modules/mod_jfbcrecommendationsbar_' . $jVersion . '_v5.1.0.zip', 'install' => true);
        $this->modules[] = array('name' => 'JFBCRequest', 'file' => 'modules/mod_jfbcrequest_' . $jVersion . '_v5.1.0.zip', 'install' => true);
        $this->modules[] = array('name' => 'JFBCSend', 'file' => 'modules/mod_jfbcsend_' . $jVersion . '_v5.1.0.zip', 'install' => true);
        $this->modules[] = array('name' => 'JFBCSharedActivity', 'file' => 'modules/mod_jfbcsharedactivity_' . $jVersion . '_v5.1.0.zip', 'install' => true);
        $this->modules[] = array('name' => 'JFBCShareDialog', 'file' => 'modules/mod_jfbcsharedialog_' . $jVersion . '_v5.1.0.zip', 'install' => true);
        //Open Graph Plugins
        $this->opengraph[] = array('name' => 'Content', 'file' => 'plugins/opengraph/plg_opengraph_content_' . $jVersion . '_v5.1.1.zip', 'group' => 'opengraph', 'install' => true);
        $this->opengraph[] = array('name' => 'Custom', 'file' => 'plugins/opengraph/plg_opengraph_custom_' . $jVersion . '_v5.1.0.zip', 'group' => 'opengraph', 'install' => true);
        $this->opengraph[] = array('name' => 'EasyBlog', 'file' => 'plugins/opengraph/plg_opengraph_easyblog_' . $jVersion . '_v5.1.0.zip', 'group' => 'opengraph', 'install' => $this->isThirdPartyInstalled('com_easyblog'));
        $this->opengraph[] = array('name' => 'JomSocial', 'file' => 'plugins/opengraph/plg_opengraph_jomsocial_' . $jVersion . '_v5.1.0.zip', 'group' => 'opengraph', 'install' => $this->isThirdPartyInstalled('com_community'));
        $this->opengraph[] = array('name' => 'JReviews', 'file' => 'plugins/opengraph/plg_opengraph_jreviews_' . $jVersion . '_v5.1.2.zip', 'group' => 'opengraph', 'install' => $this->isThirdPartyInstalled('com_jreviews'));
        $this->opengraph[] = array('name' => 'K2', 'file' => 'plugins/opengraph/plg_opengraph_k2_' . $jVersion . '_v5.1.0.zip', 'group' => 'opengraph', 'install' => $this->isThirdPartyInstalled('com_k2'));
        //Social Profile Plugins
        $this->socialprofiles[] = array('name' => 'AgoraPro', 'file' => 'plugins/socialprofiles/plg_socialprofiles_agorapro_' . $jVersion . '_v5.1.0.zip', 'group' => 'socialprofiles', 'install' => $this->isThirdPartyInstalled('com_agorapro'));
        $this->socialprofiles[] = array('name' => 'CommunityBuilder', 'file' => 'plugins/socialprofiles/plg_socialprofiles_communitybuilder_' . $jVersion . '_v5.1.0.zip', 'group' => 'socialprofiles', 'install' => $this->isThirdPartyInstalled('com_comprofiler'));
        $this->socialprofiles[] = array('name' => 'JomSocial', 'file' => 'plugins/socialprofiles/plg_socialprofiles_jomsocial_' . $jVersion . '_v5.1.2.zip', 'group' => 'socialprofiles', 'install' => $this->isThirdPartyInstalled('com_community'));
        $this->socialprofiles[] = array('name' => 'K2', 'file' => 'plugins/socialprofiles/plg_socialprofiles_k2_' . $jVersion . '_v5.1.0.zip', 'group' => 'socialprofiles', 'install' => $this->isThirdPartyInstalled('com_k2'));
        $this->socialprofiles[] = array('name' => 'Kunena', 'file' => 'plugins/socialprofiles/plg_socialprofiles_kunena_' . $jVersion . '_v5.1.1.zip', 'group' => 'socialprofiles', 'install' => $this->isThirdPartyInstalled('com_kunena'));
        $this->socialprofiles[] = array('name' => 'Virtuemart2', 'file' => 'plugins/socialprofiles/plg_socialprofiles_virtuemart2_' . $jVersion . '_v5.1.0.zip', 'group' => 'socialprofiles', 'install' => $this->isThirdPartyInstalled('com_virtuemart'));
    }

    private function isThirdPartyInstalled($component)
    {
        return JFolder::exists(JPATH_SITE . '/components/' . $component);
    }

    public function preflight($type, $parent)
    {
        // Check if Joomla version is correct. Mainly, J2.5 can't be installed on J3.0
        $jVersion = new JVersion();
        
            if (version_compare($jVersion->getShortVersion(), '2.5.5', '<'))
            {
                Jerror::raiseWarning(null, 'JFBConnect v5.x requires Joomla 2.5.5 or higher. Please upgrade Joomla or use the previous JFBConnect v4.x release.');
                return false;
            }
            if (version_compare($jVersion->getShortVersion(), '3.0.0', '>='))
            {
                Jerror::raiseWarning(null, 'This installer is for Joomla 2.5. Please download the Joomla 3.x installer from <a href="http://www.sourcecoast.com/" target="_BLANK">SourceCoast</a>.');
                return false;
            }
        
        

        return true;
    }

    public function install($parent)
    {
        return true;
    }

    public function update($parent)
    {
        $this->savePluginState();
        $this->disablePlugins();

        return true;
    }

    public function postflight($type, $parent)
    {
        // Run required updates that may not have happened if user uninstalls and does a fresh install
        $this->updateDatabase();
        $this->installPackages();
        $this->migrateProfilePluginSettings();
        $this->migrateProfilePluginSettings51();

        $this->enablePlugins($this->systemPluginEnabled, $this->authPluginEnabled, $this->userPluginEnabled, $this->contentPluginEnabled);
    }

    /*
         * $parent is the class calling this method
         * uninstall runs before any other action is taken (file removal or database processing).
         */
    public function uninstall($parent)
    {
        $this->disablePlugins();
    }

    // CUSTOM JFBCONNECT FUNCTIONS
    private function savePluginState()
    {
        $db = JFactory::getDBO();
        $db->setQuery(
            "SELECT element, enabled FROM #__extensions " .
            "WHERE (element = 'jfbconnectauth' AND folder = 'authentication' AND type = 'plugin') " .
            "	OR (element = 'jfbcsystem' AND folder = 'system' AND type = 'plugin') " .
            "	OR (element = 'jfbccontent' AND folder = 'content' AND type = 'plugin') " .
            "	OR (element = 'jfbconnectuser' AND folder = 'user' AND type = 'plugin')");
        $pluginValues = $db->loadObjectList();

        if ($pluginValues)
        {
            foreach ($pluginValues as $plugin)
            {
                $pluginName = $plugin->element;
                $pluginPublished = $plugin->enabled;

                if ($pluginName == 'jfbconnectauth')
                    $this->authPluginEnabled = $pluginPublished;
                else if ($pluginName == 'jfbconnectuser')
                    $this->userPluginEnabled = $pluginPublished;
                else if ($pluginName == 'jfbcsystem')
                    $this->systemPluginEnabled = $pluginPublished;
                else if ($pluginName == 'jfbccontent')
                    $this->contentPluginEnabled = $pluginPublished;
            }
        }
    }

    private function disablePlugins()
    {
        $this->enablePlugins("0", "0", "0", "0");
    }

    private function enablePlugins($enableSystem, $enableAuth, $enableUser, $enableContent)
    {
        $db = JFactory::getDBO();
        $db->setQuery("UPDATE #__extensions SET enabled=" . $enableSystem . " WHERE element = 'jfbcsystem' AND folder = 'system' AND type = 'plugin';");
        $db->execute();
        $db->setQuery("UPDATE #__extensions SET enabled=" . $enableAuth . " WHERE element = 'jfbconnectauth' AND folder = 'authentication' AND type = 'plugin';");
        $db->execute();
        $db->setQuery("UPDATE #__extensions SET enabled=" . $enableUser . " WHERE element = 'jfbconnectuser' AND folder = 'user' AND type = 'plugin';");
        $db->execute();
        $db->setQuery("UPDATE #__extensions SET enabled=" . $enableContent . " WHERE element = 'jfbccontent' AND folder = 'content' AND type = 'plugin';");
        $db->execute();
    }

    private function updateDatabase()
    {
        // If user uninstalled JFBConnect and is re-installing, the tables will exist, but upgrade SQL files won't be called
        // Add SQL calls here as a backup
        $db = JFactory::getDBO();
        $db->setDebug(0);
        $db->setQuery("SELECT value FROM #__jfbconnect_config WHERE `setting` = 'db_version'");
        $dbVersion = $db->loadResult();
        switch ($dbVersion)
        {
            case null:
            case "":
                $this->runUpdateSQL('4.1.0');
            case "4.1.0":
                $this->runUpdateSQL('4.2.0');
            case "4.2.0":
                $this->runUpdateSQL('4.3.0');
            case "4.3.0":
                $this->runUpdateSQL('5.1.0');
            default:
                break;
        }
    }

    private function runUpdateSQL($version)
    {
        $buffer = file_get_contents(JPATH_ADMINISTRATOR . '/components/com_jfbconnect/install/sql/updates/' . $version . '.sql');

        // Graceful exit and rollback if read not successful
        if ($buffer === false)
        {
            JError::raiseWarning(1, JText::_('JLIB_INSTALLER_ERROR_SQL_READBUFFER'));
            return false;
        }

        $db = JFactory::getDBO();

        // Create an array of queries from the sql file
        
        
            $queries = JDatabase::splitSql($buffer);
        

        $update_count = 0;
        if (count($queries) != 0)
        {
            // Process each query in the $queries array (split out of sql file).
            foreach ($queries as $query)
            {
                $query = trim($query);
                if ($query != '' && $query{0} != '#')
                {
                    $db->setQuery($query);

                    if (!$db->execute())
                    {
                        JLog::add(JText::sprintf('JLIB_INSTALLER_ERROR_SQL_ERROR', $db->stderr(true)), JLog::WARNING, 'jerror');
                        return false;
                    }
                    $update_count++;
                }
            }
        }
    }

    private function installPackages()
    {
        // Get current version number
        ?>

        <table>
            <tr>
                <td width="100px"><img
                            src="<?php print JURI::root(); ?>/administrator/components/com_jfbconnect/assets/images/jfbconn.png"
                            width="100px"></td>
                <td><h2>JFBConnect v<?php echo $this->jfbcVersion; ?></h2></td>
            </tr>
        </table>
        <?php echo $this->showDoneMessage(); ?>
        <h3>Installation Successful!</h3>

        <?php
        jimport('joomla.installer.helper');
        jimport('joomla.installer.adapters.plugin');
        jimport('joomla.filesystem.folder');

        echo '<table class="adminlist table table-striped" width="100%">';
        echo '<thead><tr><th class="title">Extension</th><th width="40%">Status</th></tr></thead>';
        echo '<tbody>';
        echo '<tr class="row0"><td>JFBConnect Component</td><td><span style="color:green; font-weight:bold">Installed</span></td></tr>';
        echo $this->installPackageList($this->packages);
        echo '<tr><th><strong>Modules</strong></th><th><center>Status</center></th></tr>';
        echo $this->installPackageList($this->modules);
        echo '<tr><th><strong>Open Graph Plugins</strong></th><th><center>Status</center></th></tr>';
        echo $this->installPackageList($this->opengraph);
        echo '<tr><th><strong>Social Profile Plugins</strong></th><th><center>Status</center></th></tr>';
        echo $this->installPackageList($this->socialprofiles);
        echo '</tbody>';
        echo '</table>';
    }

    private function installPackageList($packages)
    {
        foreach ($packages as $package)
        {
            $installer = new JInstaller();
            $installer->setOverwrite(true);
            $pkgName = $package['name'];
            $pkgFile = $package['file'];
            $pkgInstall = $package['install'];

            $this->installedRow++;

            if (!$pkgInstall)
                $installed = '<span style="color:blue; font-weight:bold">Not Installed. Third Party Extension not found.</span>';
            else
            {
                $pkg = JInstallerHelper::unpack(JPATH_ADMINISTRATOR . '/components/com_jfbconnect/install/packages/' . $pkgFile);
                if ($installer->install($pkg['dir']))
                    $installed = '<span style="color:green; font-weight:bold">Installed</span>';
                else
                    $installed = '<span style="color:red; font-weight:bold">Not Installed. Please install manually.</span>';

                JFolder::delete($pkg['extractdir']);
            }
            ?>
            <tr class="row<?php echo($this->installedRow % 2); ?>">
                <td><?php echo $pkgName; ?></td>
                <td><?php echo $installed; ?></td>
            </tr>
        <?php
        }
    }

    private function showDoneMessage()
    {
        ?>
        <p style="font-weight:bold; margin-top:20px">To configure and optimize JFBConnect, it's recommended to run Autotune whenever you install or upgrade:</p>
        <center><a href="index.php?option=com_jfbconnect&view=autotune"
                   style="background-color:#025A8D;color:#FFFFFF;height:35px;padding:15px 45px;font-weight:bold;font-size:18px;line-height:60px;
                   text-decoration:none;text-shadow:0 -1px 1px #565656;-webkit-border-radius:7px;border-radius:7px;-webkit-box-shadow:0 1px 3px 0 #565656;
                   box-shadow:0 1px 3px 0 #565656;">Run Autotune Now</a></center>
    <?php
    }

    /*
     * JFBConnect v5.0 - Removed JFBCProfile plugins and moved to SocialProfiles plugins. Old plugins used a 1-row per setting in
     * #__jfbconnect_config. New plugins use a 1-row json variable for all settings that are loaded into a registry.
     * This function converts old settings to new format, if they exist.
     */
    private function migrateProfilePluginSettings()
    {
        $db = JFactory::getDBO();
        $query = $db->getQuery(true);
        $query->select("setting,value")->from("#__jfbconnect_config")->where('`setting` LIKE "profiles_%"')->order('setting');
        $rows = $db->setQuery($query)->loadObjectList();

        if (!empty($rows))
        {
            require_once(JPATH_ADMINISTRATOR . '/components/com_jfbconnect/models/config.php');
            $configModel = new JFBConnectModelConfig();
            $pluginName = "";
            $reg = new JRegistry();
            foreach ($rows as $row)
            {
                $values = explode("_", $row->setting);
                if ($pluginName != $values[1])
                {
                    $pluginName = $values[1];
                    // Remove the previous profiles_xyz settings from the config table
                    $query = $db->getQuery(true);
                    $query->delete('#__jfbconnect_config')->where('`setting` LIKE "profiles_' . $pluginName . '%"');
                    $db->setQuery($query)->execute();
                }
                unset($values[0]);
                unset($values[1]);
                $settingName = implode("_", $values);
                $value = $row->value;
                if ($settingName == "status_updates_pull_from_fb")
                    $settingName = "import_status";
                if ($settingName == "field_map")
                {
                    $fieldMap = unserialize($value);
                    $newMap = new stdClass();
                    foreach ($fieldMap as $key => $value)
                    {
                        if ($pluginName == "jomsocial")
                            $key = 'field' . $key;
                        $newMap->$key = $value;
                    }
                    $value = $newMap;
                }
                $reg->set($settingName, $value);
                $configModel->update('profile_' . $pluginName, $reg->toString());
            }
        }
    }

    private function migrateProfilePluginSettings51()
    {
        $db = JFactory::getDBO();
        $query = $db->getQuery(true);
        $query->select("setting,value")->from("#__jfbconnect_config")->where('`setting` LIKE "profile_%"')->order('setting');
        $rows = $db->setQuery($query)->loadObjectList();
        if (!empty($rows))
        {
            require_once(JPATH_ADMINISTRATOR . '/components/com_jfbconnect/models/config.php');
            $configModel = new JFBConnectModelConfig();
            foreach ($rows as $row)
            {
                $values = explode("_", $row->setting);
                $pluginName = $values[1];

                $settings = new JRegistry();
                $settings->loadString($row->value);
                if ($settings->exists('field_map') && !$settings->exists('field_map.facebook'))
                {
                    $fieldMap = clone($settings->get('field_map'));
                    if ($pluginName == "jomsocial")
                    {
                        $newMap = new stdClass();
                        foreach ($fieldMap as $key => $value)
                        {
                            $newKey = str_replace('field', '', $key);
                            $newMap->$newKey = $value;
                        }
                        $fieldMap = $newMap;
                    }
                    $settings->set("field_map", null);
                    $settings->set("field_map.facebook", $fieldMap);
                    $configModel->update('profile_' . $pluginName, $settings->toString());
                }
            }
        }

    }

}