<?php
/**
 * @package        JFBConnect
 * @copyright (C) 2009-2013 by Source Coast - All rights reserved
 * @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 */
defined('_JEXEC') or die('Restricted access');
?>
<div class="sourcecoast">
    <?php
    if ($this->network == 'facebook')
        echo 'We recommend visiting the <a href="http://www.sourcecoast.com/jfbconnect/docs/third-party-integration/facebook-integration-for-community-builder" target="_blank" title="Facebook Integration for Community Builder">Facebook Integration for Community Builder</a> page for common support questions.';
    else if ($this->network == 'linkedin')
        echo 'We recommend visiting the <a href="http://www.sourcecoast.com/jlinked/docs/third-party-integration/linkedin-integration-for-community-builder" target="_blank" title="LinkedIn Integration for Community Builder">LinkedIn Integration for Community Builder</a> page for common support questions.';
    ?>

    <div>
        <div class="config_row">
            <div class="config_setting header">General Setting</div>
            <div class="config_option header">Options</div>
            <div style="clear:both"></div>
        </div>
        <?php if ($this->network == 'facebook') : ?>
            <div class="config_row">
                <div class="config_setting hasTip"
                     title="If set to yes, a user's avatar and field mappings (as set below) will be imported each and every time they
             login to your site. If set to No, the import will only take place on their initial registration. After that,
             any updates to their social network profile will not be reflected on your site.">Always Import Profile Data:
                </div>
                <div class="config_option">
                    <fieldset id="profiles_communitybuilder_import_always" class="radio btn-group">
                        <input type="radio" id="profiles_communitybuilder_import_always1" name="profiles_communitybuilder_import_always"
                               value="1" <?php echo $this->settings->get('import_always') ? 'checked="checked"' : ""; ?> />
                        <label for="profiles_communitybuilder_import_always1">Yes</label>
                        <input type="radio" id="profiles_communitybuilder_import_always0" name="profiles_communitybuilder_import_always"
                               value="0" <?php echo $this->settings->get('import_always') ? '""' : 'checked="checked"'; ?> />
                        <label for="profiles_communitybuilder_import_always0">No</label>
                    </fieldset>
                </div>
                <div style="clear:both"></div>
            </div>
        <?php endif; ?>
        <div class="config_row">
            <div class="config_setting hasTip" title="Set this option to Yes to automatically set the user's Community Builder avatar to their current social network profile
             picture after connecting their user.">Import Avatar:
            </div>
            <div class="config_option">
                <fieldset id="profiles_communitybuilder_import_avatar" class="radio btn-group">
                    <input type="radio" id="profiles_communitybuilder_import_avatar1" name="profiles_communitybuilder_import_avatar"
                           value="1" <?php echo $this->settings->get('import_avatar') ? 'checked="checked"' : ""; ?> />
                    <label for="profiles_communitybuilder_import_avatar1">Yes</label>
                    <input type="radio" id="profiles_communitybuilder_import_avatar0" name="profiles_communitybuilder_import_avatar"
                           value="0" <?php echo $this->settings->get('import_avatar') ? '""' : 'checked="checked"'; ?> />
                    <label for="profiles_communitybuilder_import_avatar0">No</label>
                </fieldset>
            </div>
            <div style="clear:both"></div>
        </div>
        <div class="config_row">
            <div class="config_setting hasTip" title="If set to yes, new users will automatically be activated with Community Builder.
        If set to no and activation is enabled in Community Builder, the user will need to activate their account. The user will need
        to first log out the site and then activate. Otherwise, the activation will fail.">Skip CB Activation:
            </div>
            <div class="config_option">
                <fieldset id="profiles_communitybuilder_skip_activation" class="radio btn-group">
                    <input type="radio" id="profiles_communitybuilder_skip_activation1" name="profiles_communitybuilder_skip_activation"
                           value="1" <?php echo $this->settings->get('skip_activation') ? 'checked="checked"' : ""; ?> />
                    <label for="profiles_communitybuilder_skip_activation1">Yes</label>
                    <input type="radio" id="profiles_communitybuilder_skip_activation0" name="profiles_communitybuilder_skip_activation"
                           value="0" <?php echo $this->settings->get('skip_activation') ? '""' : 'checked="checked"'; ?> />
                    <label for="profiles_communitybuilder_skip_activation0">No</label>
                </fieldset>
            </div>
            <div style="clear:both"></div>
        </div>
        <div class="config_row">
            <div class="config_setting hasTip" title="If set to yes, new users will not be required to accept Terms & Conditions.
        If set to no and Enable Terms & Conditions is enabled in Community Builder, the user will need to accept your terms
        and conditions.">CB Terms of Service:
            </div>
            <div class="config_option">
                <fieldset id="profiles_communitybuilder_skip_tos" class="radio btn-group">
                    <input type="radio" id="profiles_communitybuilder_skip_tos1" name="profiles_communitybuilder_skip_tos"
                           value="1" <?php echo $this->settings->get('skip_tos') ? 'checked="checked"' : ""; ?> />
                    <label for="profiles_communitybuilder_skip_tos1">Skip</label>
                    <input type="radio" id="profiles_communitybuilder_skip_tos0" name="profiles_communitybuilder_skip_tos"
                           value="0" <?php echo $this->settings->get('skip_tos') ? '""' : 'checked="checked"'; ?> />
                    <label for="profiles_communitybuilder_skip_tos0">Show</label>
                </fieldset>
            </div>
            <div style="clear:both"></div>
        </div>
        <div class="config_row">
            <div class="config_setting hasTip" title="On the Login/Registration page, show Community Builder custom profile fields in the registration section.<br/>
                This will only show fields which are marked as Published, Registration and Profile.">Show Profile Fields:
            </div>
            <div class="config_option">
                <fieldset id="profiles_communitybuilder_registration_show_fields" class="radio btn-group">
                    <input type="radio" id="profiles_communitybuilder_registration_show_fields2" name="profiles_communitybuilder_registration_show_fields"
                           value="2" <?php echo $this->settings->get('registration_show_fields') == '2' ? 'checked="checked"' : ""; ?> />
                    <label for="profiles_communitybuilder_registration_show_fields2">All</label>
                    <input type="radio" id="profiles_communitybuilder_registration_show_fields1" name="profiles_communitybuilder_registration_show_fields"
                           value="1" <?php echo $this->settings->get('registration_show_fields') == '1' ? 'checked="checked"' : ""; ?> />
                    <label for="profiles_communitybuilder_registration_show_fields1">Required only</label>
                    <input type="radio" id="profiles_communitybuilder_registration_show_fields0" name="profiles_communitybuilder_registration_show_fields"
                           value="0" <?php echo $this->settings->get('registration_show_fields') == '0' ? 'checked="checked"' : ""; ?> />
                    <label for="profiles_communitybuilder_registration_show_fields0">None</label>
                </fieldset>
            </div>
            <div style="clear:both"></div>
        </div>
        <div class="config_row">
            <div class="config_setting hasTip" title="On the Login/Registration page, show the Community Builder custom profile fields in the registration section which will be imported from the Social Network.
                  If set to Show, any fields that will be imported from the Social Network will be shown. If set to Hide, Social Network fields will be hidden.<br/>
                  Use this option with 'Show Profile Fields' to limit the fields shown on registration.">Show Imported Fields:
            </div>
            <div class="config_option">
                <fieldset id="profiles_communitybuilder_imported_show_fields" class="radio btn-group">
                    <input type="radio" id="profiles_communitybuilder_imported_show_fields1" name="profiles_communitybuilder_imported_show_fields"
                           value="1" <?php echo $this->settings->get('imported_show_fields') == '1' ? 'checked="checked"' : ""; ?> />
                    <label for="profiles_communitybuilder_imported_show_fields1">Show</label>
                    <input type="radio" id="profiles_communitybuilder_imported_show_fields0" name="profiles_communitybuilder_imported_show_fields"
                           value="0" <?php echo $this->settings->get('imported_show_fields') == '0' ? 'checked="checked"' : ""; ?> />
                    <label for="profiles_communitybuilder_imported_show_fields0">Hide</label>
                </fieldset>
            </div>
            <div style="clear:both"></div>
        </div>
    </div>
    <?php
    if ($this->network == 'facebook')
        echo $this->getFieldMappingHtml(); // New call in JFBConnect v5.1
    else
    {
        ?>
        <fieldset>
            <legend>Community Builder <-> Social Network field mapping</legend>
            <table>
                <tr>
                    <th>Community Builder Field</th>
                    <th>Social Network Field</th>
                </tr>
                <?php
                foreach ($this->profileFields as $profileField)
                {
                    $selectedValue = $this->settings->get('field_map.' . $profileField->id, '0'); // default to 0

                    echo '<tr><td>';
                    echo $profileField->name;
                    echo '</td><td>';
                    echo '<select name="profiles_communitybuilder_field_map' . $profileField->id . '">';
                    foreach ($socialNetworkProfileFields as $name => $providerField)
                    {
                        if ($name == $selectedValue)
                            $selected = 'selected';
                        else
                            $selected = '';
                        echo '<option value="' . $name . '" ' . $selected . '>' . $providerField . '</option>';
                    }
                    echo '</select>';
                    echo '</td></tr>';
                }
                ?>
            </table>
        </fieldset>
    <?php
    }
    ?>
</div>