<?php
/**
 * @package        JFBConnect
 * @copyright (C) 2009-2013 by Source Coast - All rights reserved
 * @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 */
// no direct access
defined('_JEXEC') or die('Restricted access');

class plgsocialprofilesjomsocialInstallerScript
{
    var $SCreqs = array(
        array('name' => 'JFBConnect', 'version' => '5.0.1', 'element' => 'com_jfbconnect'),
        array('name' => 'JLinked', 'version' => '2.1.0', 'element' => 'com_jlinked')
    );
    var $extReqs = array(
        array('name' => 'JomSocial', 'version' => '2.4.0', 'element' => 'com_community')
    );

    public function preflight($type, $parent)
    {
        $SCreqsMet = true;
        $extReqsMet = true;
        // First, check any SourceCoast requirements. Meeting any will pass
        if (isset($this->SCreqs) && count($this->SCreqs) > 0)
        {
            $SCreqsMet = false;
            $missingVersions = '';
            foreach ($this->SCreqs as $req)
            {
                $currentVersion = $this->getInstalledVersion($req['element']);
                if ($currentVersion && version_compare($currentVersion, $req['version'], '>='))
                    $SCreqsMet = true;
                else
                {
                    if ($missingVersions != "")
                        $missingVersions .= " or ";
                    $missingVersions .= $req['name'] . ' v' . $req['version'];
                }
            }

            if (!$SCreqsMet)
            {
                JFactory::getApplication()->enqueueMessage(
                    'This plugin requires ' . $missingVersions . ' or later to be installed.
                    Please download the latest releases from <a href="http://www.sourcecoast.com/" target="_BLANK">SourceCoast</a>.',
                    'error'
                );
            }
        }

        if (isset($this->extReqs) && count($this->extReqs) > 0)
        {
            foreach ($this->extReqs as $req)
            {
                $currentVersion = $this->getInstalledVersion($req['element']);
                if (!$currentVersion || version_compare($currentVersion, $req['version'], '<'))
                {
                    $extReqsMet = false;
                    $installStr = 'This plugin requires ' . $req['name'] . ' v' . $req['version'] . ' or later to be installed.';
                    if($currentVersion != '')
                        $installStr .= ' You are using v' . $currentVersion . '.';
                    JFactory::getApplication()->enqueueMessage( $installStr, 'error');
                }
            }
        }


        if ($SCreqsMet && $extReqsMet)
            return true;
        else
            return false;
    }

    public function postFlight()
    {
        $db = JFactory::getDBO();
        $query = $db->getQuery(true);
        $query->select('extension_id')->from('#__extensions')->where('element="jfbcjsactivity" AND enabled=1');
        $db->setQuery($query);
        $id = $db->loadResult();
        if ($id)
        {
            JFactory::getApplication()->enqueueMessage('The JFBConnect - FB Wall Integration plugin for JomSocial was detected and has been disabled.
                 This release of the JomSocial Social Profile plugin replaces the features in that plugin.<br/>
                The JFBConnect - FB Wall Integration plugin should be uninstalled as it is no longer used.',
                'warning');
            $query = $db->getQuery(true);
            $query->update('#__extensions')->set('enabled=0')->where('element="jfbcjsactivity"');
            $db->setQuery($query);
            $db->execute();
        }
    }

    private function getInstalledVersion($element)
    {
        $db = JFactory::getDBO();
        $query = $db->getQuery(true);
        $query->select('manifest_cache')->from('#__extensions')->where('element="' . $element . '"');
        $db->setQuery($query);
        $manifest = $db->loadResult();
        $manifest = json_decode($manifest);
        return $manifest->version;
    }
}