<?php
/**
 * @package        JFBConnect
 * @copyright (C) 2009-2013 by Source Coast - All rights reserved
 * @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 */
defined('_JEXEC') or die('Restricted access');

jimport('joomla.plugin.plugin');
jimport('sourcecoast.utilities');

/**
 * Facebook User Plugin
 */
class plgUserJFBConnectUser extends JPlugin
{
    function plgUserJFBConnectUser(& $subject, $config)
    {
        parent::__construct($subject, $config);
    }

    function onUserLogout($user, $options = array())
    {
        // Disable auto-logins for session length after a logout. Prevents auto-logins
        $config = JFactory::getConfig();
        $lifetime = $config->get('lifetime', 15);
        setcookie('jfbconnect_autologin_disable', 1, time() + ($lifetime * 60));
        setcookie('jfbconnect_permissions_granted', '', time() - 10000, "/"); // clear the granted permissions cookie

        // Tell Facebook to delete session information stored for this user.
        $factoryFile = JPATH_ROOT . '/components/com_jfbconnect/libraries/factory.php';
        require_once($factoryFile);
        JFBCFactory::provider('facebook')->client->destroySession();

        return true;
    }

    function onUserBeforeDelete($user)
    {
        $db = JFactory::getDbo();
        $query = $db->getQuery(true);
        $query->delete($db->qn('#__jfbconnect_user_map'))
                ->where($db->qn('j_user_id') . "=" . $db->q($user['id']));
        $db->setQuery($query);
        $db->execute();

        // Remove other user data from open graph tables
        $query = $db->getQuery(true);
        $query->delete($db->qn('#__opengraph_activity'))
                ->where($db->qn('user_id') . "=" . $db->q($user['id']));
        $db->setQuery($query);
        $db->execute();
    }

}
