<?php
/**
 * @package        JFBConnect
 * @copyright (C) 2009-2013 by Source Coast - All rights reserved
 * @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 */
defined('_JEXEC') or die('Restricted access');
?>
<div class="sourcecoast">
<?php
if ($this->network == 'facebook')
    echo 'We recommend visiting the <a
            href="http://www.sourcecoast.com/jfbconnect/docs/third-party-integration/facebook-integration-for-jomsocial"
            target="_blank" title="Facebook Integration for JomSocial">Facebook Integration for
        JomSocial</a> page for common support questions.';
else if ($this->network == 'linkedin')
    echo 'We recommend visiting the <a
            href="http://www.sourcecoast.com/jlinked/docs/third-party-integration/linkedin-integration-for-jomsocial"
            target="_blank" title="LinkedIn Integration for JomSocial">LinkedIn Integration for
        JomSocial</a> page for common support questions.';
?>
<div>
    <div class="config_row">
        <div class="config_setting header">General Setting</div>
        <div class="config_option header">Options</div>
        <div style="clear:both"></div>
    </div>
    <?php if ($this->network == 'facebook') : ?>
        <div class="config_row">
            <div class="config_setting hasTip"
                 title="If set to yes, a user's avatar and field mappings (as set below) will be imported each and every time they
                         login to your site. If set to No, the import will only take place on their initial registration. After that,
                         any updates to their social network profile will not be reflected on your site.">
                Always Import Profile Data:
            </div>
            <div class="config_option">
                <fieldset id="profiles_jomsocial_import_always" class="radio btn-group">
                    <input type="radio" id="profiles_jomsocial_import_always1" name="profiles_jomsocial_import_always"
                           value="1" <?php echo $this->settings->get('import_always') ? 'checked="checked"'
                            : ""; ?> />
                    <label for="profiles_jomsocial_import_always1">Yes</label>
                    <input type="radio" id="profiles_jomsocial_import_always0" name="profiles_jomsocial_import_always"
                           value="0" <?php echo $this->settings->get('import_always') ? '""'
                            : 'checked="checked"'; ?> />
                    <label for="profiles_jomsocial_import_always0">No</label>
                </fieldset>
            </div>
            <div style="clear:both"></div>
        </div>
    <?php endif; ?>
    <div class="config_row">
        <div class="config_setting hasTip"
             title="Set this option to Yes to automatically set the user's JomSocial avatar to their current social network profile
                            picture after connecting their user.">
            Import Avatar:
        </div>
        <div class="config_option">
            <fieldset id="profiles_jomsocial_import_avatar" class="radio btn-group">
                <input type="radio" id="profiles_jomsocial_import_avatar1" name="profiles_jomsocial_import_avatar"
                       value="1" <?php echo $this->settings->get('import_avatar') ? 'checked="checked"'
                        : ""; ?> />
                <label for="profiles_jomsocial_import_avatar1">Yes</label>
                <input type="radio" id="profiles_jomsocial_import_avatar0" name="profiles_jomsocial_import_avatar"
                       value="0" <?php echo $this->settings->get('import_avatar') ? '""'
                        : 'checked="checked"'; ?> />
                <label for="profiles_jomsocial_import_avatar0">No</label>
            </fieldset>
        </div>
        <div style="clear:both"></div>
    </div>
    <?php if ($this->network == 'facebook') : ?>
        <div class="config_row">
            <div class="config_setting hasTip"
                 title="Set to Yes to import the user's cover photo from Facebook or Google.">
                Import Cover Photo:
            </div>
            <div class="config_option">
                <fieldset id="profiles_jomsocial_import_cover_photo" class="radio btn-group">
                    <input type="radio" id="profiles_jomsocial_import_cover_photo1" name="profiles_jomsocial_import_cover_photo"
                           value="1" <?php echo $this->settings->get('import_cover_photo') ? 'checked="checked"'
                            : ""; ?> />
                    <label for="profiles_jomsocial_import_cover_photo1">Yes</label>
                    <input type="radio" id="profiles_jomsocial_import_cover_photo0" name="profiles_jomsocial_import_cover_photo"
                           value="0" <?php echo $this->settings->get('import_cover_photo') ? '""'
                            : 'checked="checked"'; ?> />
                    <label for="profiles_jomsocial_import_cover_photo0">No</label>
                </fieldset>
            </div>
            <div style="clear:both"></div>
        </div>
    <?php endif; ?>
    <div class="config_row">
        <div class="config_setting hasTip"
             title="If set to show, new users will be required to accept Terms & Conditions. If set to Skip, the ToS's will not be shown.<br/>
        <b>This setting only has effect when 'Registration Flow' is set to 'Normal Registration'.</b>">
            Skip JS Terms of Service:
        </div>
        <div class="config_option">
            <fieldset id="profiles_jomsocial_skip_tos" class="radio btn-group">
                <input type="radio" id="profiles_jomsocial_skip_tos1" name="profiles_jomsocial_skip_tos"
                       value="1" <?php echo $this->settings->get('skip_tos') ? 'checked="checked"'
                        : ""; ?> />
                <label for="profiles_jomsocial_skip_tos1">Skip</label>
                <input type="radio" id="profiles_jomsocial_skip_tos0" name="profiles_jomsocial_skip_tos"
                       value="0" <?php echo $this->settings->get('skip_tos') ? '""'
                        : 'checked="checked"'; ?> />
                <label for="profiles_jomsocial_skip_tos0">Show</label>
            </fieldset>
        </div>
        <div style="clear:both"></div>
    </div>
    <div class="config_row">
        <div class="config_setting hasTip"
             title="On the Login/Registration page, show JomSocial custom profile fields in the registration section.<br/>
            This will only show fields which are marked as Published and Registration.">
            Show Profile Fields:
        </div>
        <div class="config_option">
            <fieldset id="profiles_jomsocial_registration_show_fields" class="radio btn-group">
                <input type="radio" id="profiles_jomsocial_registration_show_fields2" name="profiles_jomsocial_registration_show_fields"
                       value="2" <?php echo $this->settings->get('registration_show_fields') == '2' ? 'checked="checked"' : ""; ?> />
                <label for="profiles_jomsocial_registration_show_fields2">All</label>
                <input type="radio" id="profiles_jomsocial_registration_show_fields1" name="profiles_jomsocial_registration_show_fields"
                       value="1" <?php echo $this->settings->get('registration_show_fields') == '1' ? 'checked="checked"' : ""; ?> />
                <label for="profiles_jomsocial_registration_show_fields1">Required only</label>
                <input type="radio" id="profiles_jomsocial_registration_show_fields0" name="profiles_jomsocial_registration_show_fields"
                       value="0" <?php echo $this->settings->get('registration_show_fields') == '0' ? 'checked="checked"' : ""; ?> />
                <label for="profiles_jomsocial_registration_show_fields0">None</label>
            </fieldset>
        </div>
        <div style="clear:both"></div>
    </div>

    <div class="config_row">
        <div class="config_setting hasTip"
             title="On the Login/Registration page, show JomSocial custom profile fields in the registration section which will be imported from the Social Network.<br/>
            If set to Show, any fields that will be imported from the Social Network will be shown. If set to Hide, Social Network fields will be hidden.<br/>
            Use this option with 'Show Profile Fields' to limit the fields shown on registration.">
            Show Imported Fields:
        </div>
        <div class="config_option">
            <fieldset id="profiles_jomsocial_imported_show_fields" class="radio btn-group">
                <input type="radio" id="profiles_jomsocial_imported_show_fields1" name="profiles_jomsocial_imported_show_fields"
                       value="1" <?php echo $this->settings->get('imported_show_fields') == '1' ? 'checked="checked"' : ""; ?> />
                <label for="profiles_jomsocial_imported_show_fields1">Show</label>
                <input type="radio" id="profiles_jomsocial_imported_show_fields0" name="profiles_jomsocial_imported_show_fields"
                       value="0" <?php echo $this->settings->get('imported_show_fields') == '0' ? 'checked="checked"' : ""; ?> />
                <label for="profiles_jomsocial_imported_show_fields0">Hide</label>
            </fieldset>
        </div>
    </div>
    <div style="clear:both"></div>
</div>

<?php if ($this->network == 'facebook') : ?>
    <div class="config_row">
        <div class="config_setting header">Status</div>
        <div class="config_option header">Options</div>
        <div style="clear:both"></div>
    </div>
    <div class="config_row">
        <div class="config_setting hasTip"
             title="Import the user's Social Network Status message into JomSocial.<br/>
            <b>Note: </b>Enabling this may request additional permissions of the user when they register.">
            Import Social Network Status:
        </div>
        <div class="config_option">
            <fieldset id="profiles_jomsocial_import_status" class="radio btn-group">
                <input type="radio" id="profiles_jomsocial_import_status1" name="profiles_jomsocial_import_status"
                       value="1" <?php echo $this->settings->get('import_status') ? 'checked="checked"' : ""; ?> />
                <label for="profiles_jomsocial_import_status1">Yes</label>
                <input type="radio" id="profiles_jomsocial_import_status0" name="profiles_jomsocial_import_status"
                       value="0" <?php echo $this->settings->get('import_status') ? '""' : 'checked="checked"'; ?> />
                <label for="profiles_jomsocial_import_status0">No</label>
            </fieldset>
        </div>
        <div style="clear:both"></div>
    </div>
    <div class="config_row">
        <div class="config_setting hasTip"
             title="Push the status updates posted in JomSocial to Facebook.<br/>
                <b>Note: </b>Enabling this may request additional permissions of the user when they register.">
            Push Social Network Status:
        </div>
        <div class="config_option">
            <fieldset id="profiles_jomsocial_push_status" class="radio btn-group">
                <input type="radio" id="profiles_jomsocial_push_status1" name="profiles_jomsocial_push_status"
                       value="1" <?php echo $this->settings->get('push_status') ? 'checked="checked"' : ""; ?> />
                <label for="profiles_jomsocial_push_status1">Yes</label>
                <input type="radio" id="profiles_jomsocial_push_status0" name="profiles_jomsocial_push_status"
                       value="0" <?php echo $this->settings->get('push_status') ? '""' : 'checked="checked"'; ?> />
                <label for="profiles_jomsocial_push_status0">No</label>
            </fieldset>
        </div>
        <div style="clear:both"></div>
    </div>
<?php endif; ?>

<div class="config_row">
    <div class="config_setting header">Multiple Profile Setting</div>
    <div class="config_option header">Options</div>
    <div style="clear:both"></div>
</div>
<div class="config_row">
    <div class="config_setting hasTip"
         title="This is the default profile type that will be set for the user. Depending on your JFBConnect Registration Flow setting:<br/>
                            <b>Automatic Registration:</b> The selected profile type will be used for all user's registering with JFBConnect.<br/>
                            <b>Normal Registration:</b> The selected profile will be the default profile type set for users. If the setting below to allow users to change their profile type is disabled, then the setting here will be for all users registering through JFBConnect.">
        Default Profile Type:
    </div>
    <div class="config_option">
        <fieldset id="profiles_jomsocial_profiletype_default" class="radio btn-group">
            <?php
            echo JHTML::_('select.genericlist', $this->profileTypes, 'profiles_jomsocial_profiletype_default', null, 'id', 'name', $this->settings->get('profiletype_default', null));
            ?>
        </fieldset>
    </div>
    <div style="clear:both"></div>
</div>
<div class="config_row">
    <div class="config_setting hasTip"
         title="When enabled, a drop-down will be visible to the user to let them select their profile type during registration.<br/>
            <b>Automatic Registration:</b> This setting has no effect. The selected profile type above will be used for all user's registering with JFBConnect.">
        Allow User Selection of Profile Type:
    </div>
    <div class="config_option">
        <fieldset id="profiles_jomsocial_profiletype_visible" class="radio btn-group">
            <input type="radio" id="profiles_jomsocial_profiletype_visible1"
                   name="profiles_jomsocial_profiletype_visible"
                   value="1" <?php echo $this->settings->get('profiletype_visible')
                    ? 'checked="checked"' : ""; ?> />
            <label for="profiles_jomsocial_profiletype_visible1">Yes</label>
            <input type="radio" id="profiles_jomsocial_profiletype_visible0"
                   name="profiles_jomsocial_profiletype_visible"
                   value="0" <?php echo $this->settings->get('profiletype_visible') ? '""'
                    : 'checked="checked"'; ?> />
            <label for="profiles_jomsocial_profiletype_visible0">No</label>
        </fieldset>
    </div>
    <div style="clear:both"></div>
</div>

<?php
if ($this->network == 'facebook')
    echo $this->getFieldMappingHtml(); // New call in JFBConnect v5.1
else
{
    ?>
    <fieldset>
        <legend>JomSocial <-> Social Network field mapping</legend>
        <table>
            <tr>
                <th>JomSocial Field</th>
                <th>Social Network Field</th>
            </tr>
            <?php
            foreach ($this->profileFields as $profileField)
            {
                $selectedValue = $this->settings->get('field_map.' . $profileField->id, '0'); // default to 0

                echo '<tr><td>';
                echo $profileField->name;
                echo '</td><td>';
                echo '<select name="profiles_jomsocial_field_map' . $profileField->id . '">';
                foreach ($socialNetworkProfileFields as $name => $providerField)
                {
                    if ($name == $selectedValue)
                        $selected = 'selected';
                    else
                        $selected = '';
                    echo '<option value="' . $name . '" ' . $selected . '>' . $providerField . '</option>';
                }
                echo '</select>';
                echo '</td></tr>';
            }
            ?>
        </table>
    </fieldset>
<?php
}
?>
</div>